<template>
  <div style="display: flex; justify-content: space-between;">
      <div>
        <label>Фильтры: </label>
        <input v-model="searchTerm1" />
        <input v-model="searchTerm2" />
        <input v-model="searchTerm3" />
      </div>
      <div>
        <label>Продукт: </label>
        <input v-model="productMask" />
      </div>
      <div>
        <button @click="runCmd('stop')">Остановить</button>
        <button @click="runCmd('restart')">Переобработать</button>
        <button style="background-color: red; color: white;" @click="runCmd('delete')" >Удалить</button>
      </div>
  </div>
  <table-lite
    :is-static-mode=true
    :columns="table.columns"
    :rows="table.rows"
    :total="table.totalRecordCount"
    :messages="table.messages"
    :page="page"
    :page-size="pageSize"
    @is-finished="tableLoadingFinish"
    @get-now-page="setCurrentPage" 
    @get-now-page-size="setCurrentPageSize" 
    >
  </table-lite>
</template>

<script>
import { watch, defineComponent, reactive, ref, computed } from "vue";
import TableLite from "../components/TableLite";
import axios from 'axios';
import router from "../router/index"
import { redouteProvider } from  "../config/provider"

// храним значение фильтра между переключениями 
const searchTerm1 = ref(""); // Search text
const searchTerm2 = ref(""); // Search text
const searchTerm3 = ref(""); // Search text

var storeProductMask = ""

var storeTaskPage = 1
var storePageSize = 15
var lastUpdate = null

var timer = null
let dataServer = null
let productMask = ref(""); // Search text

// собственно табличные данные 
// храним в глобальнй области, чтобы не было удаления при переходе между страницами
export let data = reactive([]);
let table = reactive({});

function updateData(response, data) {
  if (data.length == 0) {
    response.data.forEach(element => data.push(element) )   
  }
  else {
    updateStatus(response.data,data);
  }
}

function updateStatus(newData,oldData) {
  // смотрим на новые данные и либо добавляем либо обновляем
  for (let newEl of newData) {
    let oldEl = oldData.find(o => o.id_task === newEl.id_task);
    if (!oldEl) oldData.unshift(newEl);
    else {
      if (newEl.task_status != oldEl.task_status || 
          newEl.job_status != oldEl.job_status) {
        Object.assign(oldEl,newEl);
      }
    }
  }
}

let timerFindTask = null

// eslint-disable-next-line
export function updateTaskTable() {
      if (!table) return
      table.messages.noDataAvailable = 'Получение данных ...'
      let jsonData = { } 

      if (lastUpdate) { 
        jsonData['lastUpdate'] = lastUpdate.toISOString()
      }
      if (productMask.value) {
        jsonData['product_id'] = productMask.value
      }
      lastUpdate = new Date()

      // если есть uid
      const url = new URL(window.location.href)
      const uid = url.searchParams.get("uid")
      if (uid) {
        jsonData['uid'] = uid
        data.splice(0,data.length);
        lastUpdate = null
      }

      dataServer = redouteProvider + '/task'
      axios.post(dataServer, JSON.stringify(jsonData))
      .then(response => {
        updateData(response,data)
        table.messages.noDataAvailable = 'Нет данных'
      })
      .catch(error => table.messages.noDataAvailable = 'Сервер "' + dataServer + '" не отвечает ' + error)
    }

export default defineComponent({ 
  name: "App",
  components: { TableLite },
  setup() {
    
    const page = ref("")
    const pageSize = ref("")
    page.value = storeTaskPage
    pageSize.value = storePageSize

    function cleverFindTask() {
      if (timerFindTask) clearTimeout(timerFindTask);
      timerFindTask = setTimeout(() => { 
        lastUpdate = null; 
        data.splice(0,data.length);
        storeProductMask = productMask.value
        updateTaskTable() 
      } ,1000);
    }

    productMask.value = storeProductMask
    watch(productMask, () => { cleverFindTask() })

    // Table config
    table = reactive({
      columns: [
        {
          label: "task",
          field: "job",
          width: "20%",
          sortable: false,
          display: function (row) {
            let name = row.task_uid
            // если обработка только одного маршрута, то показываем последнюю сцену выходного продукта 
            if (row && row.job) {
              row.job.sort()
              let route = []
              for (let out of row.job) { 
                let short = shortName(out)
                if (route.includes(short)) continue
                route.push(short)
              }
              if (route.length == 1) name = route[0]
            }
//            console.log('row.job = ' + row.job)

            /*
            let l0 = -1
            if (row.job) l0 = row.job.indexOf('.L0')
            if (l0 > -1) name = row.job.substring(0,l0)    

            let l2 = -1
            if (row.job) l2 = row.job.indexOf('.L2')
            if (l2 > -1) name = row.job.substring(0,l2)    
            */
            return (
              '<a href="javascript:void(0)" data-id="' +
              row.id_task +
              '" class="is-rows-el job-btn">' +
              name +
              "</a>"
            );
          },
        },
        {
          label: "level",
          field: "level",
          width: "5%",
          sortable: false,
        },
        {
          label: "create",
          field: "create",
          width: "10%",
          sortable: false,
        },
        {
          label: "start",
          field: "start",
          width: "10%",
          sortable: false,
        },
        
        {
          label: "duration",
          field: "duration",
          width: "5%",
          sortable: true,
        },
        {
          label: "task_status",
          field: "task_status",
          width: "3%",
          sortable: false,
          display: function (row) {
            return (
              '<a href="javascript:void(0)" data-id="' +
              row.id_task +
              '" class="is-rows-el log-btn">' +
              row.task_status +
              "</a>"
            );
          },          
        },
        {
          label: "job_status",
          field: "job_status",
          width: "3%",
          sortable: false,
          display: function (row) {
            let resultStyle = "";
            if (row && row.job_status) resultStyle = row.job_status.toLowerCase()
            return (
              '<div class="' + resultStyle + '">' + row.job_status + '</div>'
            );
          },          
        },
      ],
      rows: computed(() => {
        return data.filter(
          (x) => {
            let fields = [x.job,x.task_status,x.job_status,x.level,x.start,x.create,x.task_uid]
            return ok(fields,searchTerm1.value) && ok(fields,searchTerm2.value) && ok(fields,searchTerm3.value)
          }
        );
      }),

      totalRecordCount: computed(() => {
        return table.rows.length;
      }),
     
      messages: {
        pagingInfo: "{0}-{1}/{2}",
        pageSizeChangeLabel: "Строк:",
        gotoPageLabel: "Перейти:",
        noDataAvailable: "Нет данных",
      },      
     });

     updateTaskTable();
     if (!timer) timer = setInterval(updateTaskTable,5000)

     const tableLoadingFinish = (elements) => {
      table.isLoading = false;
      Array.prototype.forEach.call(elements, function (element) {
        if (element.classList.contains("job-btn")) {
          element.addEventListener("click", function () { 
            goToJobList(this.dataset.id)
          });
        }
        if (element.classList.contains("log-btn")) {
          element.addEventListener("click", function () { 
            goToTaskLogList(this.dataset.id)
          });
        }
      });
    };

    const setCurrentPage = (pageNumber) => {
        storeTaskPage = pageNumber
    };
    const setCurrentPageSize = (pageSize) => {
        storePageSize = pageSize
    };

    function goToJobList (idTask) {
      router.push({ path: '/job', query: { task_id: idTask } })
    }

    function goToTaskLogList (idTask) {
      router.push({ path: '/log', query: { task_id: idTask } })
    }

    function ok (fields, value) {
      if (!value) return true
      let ret = false
      for (let field of fields) {
        ret = field && field.toString().toLowerCase().includes(value.toLowerCase())
        if (ret) break
      }
      return ret  
    }

    function runCmd(name) {
      if (!confirm('Всего заданий: ' + table.rows.length + '. Продолжить ?' )) return;

      let api = redouteProvider + '/' + name
      let rows = table.rows;
      let postData = { taskId: [] }
      for (let row of rows) 
        postData.taskId.push(row.id_task)
      axios.post(api,  JSON.stringify(postData))
          .catch(error => { alert (error) })
    }

    function shortName(name) {
      let short = name.replace(/_\d{8}_.*/, '') 
      return short
    }


    return {
      searchTerm1,
      searchTerm2,
      searchTerm3,
      productMask,
      page, pageSize,
      setCurrentPage, setCurrentPageSize,
      tableLoadingFinish,  
      table,
      runCmd,
    };
  },
});

</script>


<style scoped>

  :deep(.success) {
    color: green  
  }
  :deep(.error) {
    color: red
  }

  :deep(.vtl-table td, .vtl-table th) {
    padding: 0.4rem;
    font-size: medium;
  }


  </style>

